
union auth switch (enum {AUTH_NONE = 0, AUTH_SYS = 1, AUTH_SHORT = 2, 
		    AUTH_DH = 3, AUTH_KERB4 = 4} auth_flavor) {
  case AUTH_NONE:
    opaque body<400>;
  case AUTH_SYS:
    struct { 
	int length_of_auth_sys;
	int stamp;
	string machinename<255>;
	int uid;
	int gid;
	int gids<16>;
    } authsys_parms;
  default:
    opaque default_body<400>;
};

/* {100 {CALL {2 100000 2 0 {AUTH_NONE {}} {AUTH_NONE {}} }}} */
struct rpc_msg {
    /*unsigned*/ int xid;      /* Transaction identifier (XID) */
    union switch (enum {CALL = 0, REPLY = 1} msg_type) {
      case CALL:
	struct {
	    int rpcvers; 
	    int prog;
	    int vers;
	    int proc;
	    auth cred;
	    auth verf;
	    /* procedure specific parameters start here */
	} call_body;
      case REPLY:
	union switch (enum {MSG_ACCEPTED = 0, MSG_DENIED = 1} reply_stat) {
	  case MSG_ACCEPTED:
	    struct {
		auth verf_reply;
		union switch (enum {SUCCESS = 0, PROG_UNAVAIL = 1,
				      PROG_MISMATCH = 2, PROC_UNAVAIL = 3,
				      GARBAGE_ARGS = 4, SYSTEM_ERR = 5} acc) {
		  case SUCCESS:
		    opaque results[0];
		    /*
		     * procedure-specific results start here
		     */
		  case PROG_MISMATCH:
		    struct {
			unsigned int low;
			unsigned int high;
		    } mismatch_info;
		    
		  default:
		    /*
		     * Void.  Cases include PROG_UNAVAIL, PROC_UNAVAIL,
		     * GARBAGE_ARGS, and SYSTEM_ERR.
		     */
		    void;
		} reply_data;
	    } accepted_reply;
	  case MSG_DENIED:
	    union switch (enum {RPC_MISMATCH = 0, AUTH_ERROR = 1} reject) {
	      case RPC_MISMATCH:
		struct {
		    unsigned int low;
		    unsigned int high;
		} mismatch_info;
	      case AUTH_ERROR:
		enum {AUTH_OK = 0, AUTH_BADCRED = 1, AUTH_REJECTEDCRED = 2,
			AUTH_BADVERF = 3, AUTH_REJECTEDVERF = 4, 
			AUTH_TOOWEAK = 5, AUTH_INVALIDRESP  = 6, 
			AUTH_FAILED = 7, AUTH_KERB_GENERIC = 8,
			AUTH_TIMEEXPIRE = 9, AUTH_TKT_FILE = 10, 
			AUTH_DECODE = 11, AUTH_NET_ADDR = 12} auth_stat;
	    } rejected_reply;
	} reply_body;
    } call_reply;
};

